uses RTC_MAIN,RTC_BR,RTC_ERR,crt;

var
    Code:string;
    CodePtr:pointer;
    CodeSize:word;
    MyFunc: function (x,y,z:float):float;
    err,errp:integer;

procedure InitCode(s:string);
var SC:PSmallCompiler;
begin
  SC:=New(PCompilerForBorlandReal,Init(
          Var_('x',
          Var_('y',
          Var_('z',nil)))));

  with SC^ do
    begin
    SetData(s,err,errp,CodeSize);
    if err<>0 then Error(s,err,errp);
    GetMem(CodePtr,CodeSize);
    GetCode(@MyFunc,CodePtr^);
    end;
  Dispose(SC,Done);
end;


var r:float;
    s:string;
    i:word;
begin
 clrscr;
 InitCode('sin(y+z)*x^8');
 if err=0 then
   begin
   writeln('MyFunc(0,1,2)=',MyFunc(0,1,2):0:2);
   writeln('MyFunc(1,2,3)=',MyFunc(1,2,3):0:2);
   writeln('MyFunc(1.2,2.3,3.4)=',MyFunc(1.2,2.3,3.4):0:2);
   end;
 FreeMem(CodePtr,CodeSize);
end.

